#include "macro.h"

int _index[256] = {
  0,  /* 000 , 000 */    /*   NUL    (Null char.) */
  0,  /* 001 , 001 */    /*   SOH    (Start of Header) */
  0,  /* 002 , 002 */    /*   STX    (Start of Text) */
  0,  /* 003 , 003 */    /*   ETX    (End of Text) */
  0,  /* 004 , 004 */    /*   EOT    (End of Transmission) */
  0,  /* 005 , 005 */    /*   ENQ    (Enquiry) */
  0,  /* 006 , 006 */    /*   ACK    (Acknowledgment) */
  0,  /* 007 , 007 */    /*   BEL    (Bell) */
  0,  /* 008 , 008 */    /*    BS    (Backspace) */
  0,  /* 009 , 009 */    /*    HT    (Horizontal Tab) */
  0,  /* 010 , 00A */    /*    LF    (Line Feed) */
  0,  /* 011 , 00B */    /*    VT    (Vertical Tab) */
  0,  /* 012 , 00C */    /*    FF    (Form Feed) */
  0,  /* 013 , 00D */    /*    CR    (Carriage Return) */
  0,  /* 014 , 00E */    /*    SO    (Shift Out) */
  0,  /* 015 , 00F */    /*    SI    (Shift In) */
  0,  /* 016 , 010 */    /*   DLE    (Data Link Escape) */
  0,  /* 017 , 011 */    /*   DC1 (XON) (Device Control 1) */
  0,  /* 018 , 012 */    /*   DC2       (Device Control 2) */
  0,  /* 019 , 013 */    /*   DC3 (XOFF)(Device Control 3) */
  0,  /* 020 , 014 */    /*   DC4       (Device Control 4) */
  0,  /* 021 , 015 */    /*   NAK    (Negative Acknowledgement) */
  0,  /* 022 , 016 */    /*   SYN    (Synchronous Idle) */
  0,  /* 023 , 017 */    /*   ETB    (End of Trans. Block) */
  0,  /* 024 , 018 */    /*   CAN    (Cancel) */
  0,  /* 025 , 019 */    /*    EM    (End of Medium) */
  0,  /* 026 , 01A */    /*   SUB    (Substitute) */
  0,  /* 027 , 01B */    /*   ESC    (Escape) */
  0,  /* 028 , 01C */    /*    FS    (File Separator) */
  0,  /* 029 , 01D */    /*    GS    (Group Separator) */
  0,  /* 030 , 01E */    /*    RS    (Request to Send)(Record Separator) */
  0,  /* 031 , 01F */    /*    US    (Unit Separator) */
  0,  /* 032 , 020 */    /*    SP    (Space) */
  0,  /* 033 , 021 */    /*     !    (exclamation mark) */
  0,  /* 034 , 022 */    /*     "    (double quote) */
2,  /* 035 , 023 */    /*     #    (number sign) */
  0,  /* 036 , 024 */    /*     $    (dollar sign) */
  0,  /* 037 , 025 */    /*     %    (percent) */
  0,  /* 038 , 026 */    /*     &    (ampersand) */
  0,  /* 039 , 027 */    /*     '    (single quote) */
  0,  /* 040 , 028 */    /*     (    (left/opening parenthesis) */
  0,  /* 041 , 029 */    /*     )    (right/closing parenthesis) */
  0,  /* 042 , 02A */    /*     *    (asterisk) */
  0,  /* 043 , 02B */    /*     +    (plus) */
  0,  /* 044 , 02C */    /*     ,    (comma) */
0,  /* 045 , 02D */    /*     -    (minus or dash) */
  0,  /* 046 , 02E */    /*     .    (dot) */
  0,  /* 047 , 02F */    /*     /    (forward slash) */
  0,  /* 048 , 030 */    /*     0 */
  0,  /* 049 , 031 */    /*     1 */
  0,  /* 050 , 032 */    /*     2 */
  0,  /* 051 , 033 */    /*     3 */
  0,  /* 052 , 034 */    /*     4 */
  0,  /* 053 , 035 */    /*     5 */
  0,  /* 054 , 036 */    /*     6 */
  0,  /* 055 , 037 */    /*     7 */
  0,  /* 056 , 038 */    /*     8 */
  0,  /* 057 , 039 */    /*     9 */
  0,  /* 058 , 03A */    /*     :    (colon) */
  0,  /* 059 , 03B */    /*     ;    (semi-colon) */
  0,  /* 060 , 03C */    /*     <    (less than) */
  0,  /* 061 , 03D */    /*     =    (equal sign) */
  0,  /* 062 , 03E */    /*     >    (greater than) */
  0,  /* 063 , 03F */    /*     ?    (question mark) */
1,  /* 064 , 040 */    /*     @    (AT symbol) */
  0,  /* 065 , 041 */    /*     A */
  0,  /* 066 , 042 */    /*     B */
  0,  /* 067 , 043 */    /*     C */
  0,  /* 068 , 044 */    /*     D */
  0,  /* 069 , 045 */    /*     E */
  0,  /* 070 , 046 */    /*     F */
  0,  /* 071 , 047 */    /*     G */
  0,  /* 072 , 048 */    /*     H */
  0,  /* 073 , 049 */    /*     I */
  0,  /* 074 , 04A */    /*     J */
  0,  /* 075 , 04B */    /*     K */
  0,  /* 076 , 04C */    /*     L */
  0,  /* 077 , 04D */    /*     M */
  0,  /* 078 , 04E */    /*     N */
  0,  /* 079 , 04F */    /*     O */
  0,  /* 080 , 050 */    /*     P */
  0,  /* 081 , 051 */    /*     Q */
  0,  /* 082 , 052 */    /*     R */
  0,  /* 083 , 053 */    /*     S */
  0,  /* 084 , 054 */    /*     T */
  0,  /* 085 , 055 */    /*     U */
  0,  /* 086 , 056 */    /*     V */
  0,  /* 087 , 057 */    /*     W */
  0,  /* 088 , 058 */    /*     X */
  0,  /* 089 , 059 */    /*     Y */
  0,  /* 090 , 05A */    /*     Z */
  0,  /* 091 , 05B */    /*     [    (left/opening bracket) */
  0,  /* 092 , 05C */    /*     \    (back slash) */
  0,  /* 093 , 05D */    /*     ]    (right/closing bracket) */
  0,  /* 094 , 05E */    /*     ^    (caret/cirumflex) */
  0,  /* 095 , 05F */    /*     _    (underscore) */
  0,  /* 096 , 060 */    /*     ` */
  0,  /* 097 , 061 */    /*     a */
  0,  /* 098 , 062 */    /*     b */
  0,  /* 099 , 063 */    /*     c */
  0,  /* 100 , 064 */    /*     d */
  0,  /* 101 , 065 */    /*     e */
  0,  /* 102 , 066 */    /*     f */
  0,  /* 103 , 067 */    /*     g */
  0,  /* 104 , 068 */    /*     h */
  0,  /* 105 , 069 */    /*     i */
  0,  /* 106 , 06A */    /*     j */
  0,  /* 107 , 06B */    /*     k */
  0,  /* 108 , 06C */    /*     l */
  0,  /* 109 , 06D */    /*     m */
  0,  /* 110 , 06E */    /*     n */
  0,  /* 111 , 06F */    /*     o */
  0,  /* 112 , 070 */    /*     p */
  0,  /* 113 , 071 */    /*     q */
  0,  /* 114 , 072 */    /*     r */
  0,  /* 115 , 073 */    /*     s */
  0,  /* 116 , 074 */    /*     t */
  0,  /* 117 , 075 */    /*     u */
  0,  /* 118 , 076 */    /*     v */
  0,  /* 119 , 077 */    /*     w */
  0,  /* 120 , 078 */    /*     x */
  0,  /* 121 , 079 */    /*     y */
  0,  /* 122 , 07A */    /*     z */
  0,  /* 123 , 07B */    /*     {    (left/opening brace) */
  0,  /* 124 , 07C */    /*     |    (vertical bar) */
  0,  /* 125 , 07D */    /*     }    (right/closing brace) */
  0,  /* 126 , 07E */    /*     ~    (tilde) */
  0,  /* 127 , 07F */    /*   DEL    (delete) */
};


int matchingtable[ALPHABETSIZE][SEEDALPHABETSIZE] =
  {
    {1 , 0 , 0 },
    {1 , 1 , 0 },
    {1 , 1 , 1 },	
  };

