/*
 *  seed.cc created on Mon, 31 May 1999 21:12:51 -0400 by noe
 */    
#include "seed.h"


int seed::randomized(bool degenerated) {
  _seedMotif.clear();
  _seedMotifWithoutTrans.clear();
  // create the seed without transitions
  _seedMotifWithoutTrans = string(_weight,'#');
  for(int i=0 ; i<_span-_nbTrans-_weight ; i++){
    int p = rand()%(_seedMotifWithoutTrans.length()-1)+1;
    _seedMotifWithoutTrans.insert(p,"-");
  }
  // create the second seed
  _seedMotif = string(_seedMotifWithoutTrans);
  for(int i=0 ; i<_nbTrans ; i++){
    int p = rand()%(_seedMotif.length()-1)+1;
    _seedMotif.insert(p,"@");
  }
  return 1;
}


int seed::next(bool degenerated) {
  int r;
  do{
    r = _next();
  }while(r && !degenerated && (_seedMotif[0]=='-' || _seedMotif[_seedMotif.size()-1]=='-'));
  return r;
}

int seed::_nextWithoutTrans(){
  int endBlockJokers = 0;
  int endBlockSharps = 0; 
  
  endBlockJokers = _seedMotifWithoutTrans.find('#',0);
  if ( endBlockJokers == _span - _weight - _nbTrans ) {
    return 0;
  }
  
  endBlockSharps = _seedMotifWithoutTrans.find('-', endBlockJokers);
  if ( endBlockSharps ==  (int)_seedMotifWithoutTrans.size()) {
    return 0;
  }
  
  if (endBlockJokers == 0) {
    _seedMotifWithoutTrans.replace(endBlockSharps-1,2,"-#");
  } else {	
    _seedMotifWithoutTrans.replace(endBlockSharps-1,2,"-#");
    _seedMotifWithoutTrans.erase(0,endBlockJokers);
    _seedMotifWithoutTrans.insert(endBlockSharps-endBlockJokers-1,endBlockJokers,'-');
  }
  return 1;
}




  
int seed::_next(){
  int firstNonAt = MIN(_seedMotif.find('-',0),_seedMotif.find('#',0));
  int secondAt = _seedMotif.find('@',firstNonAt);
  
  if (firstNonAt > 0) {
    if (secondAt <= 0 /*_seedMotif.size()*/){
      if (_nextWithoutTrans()){
	_seedMotif = string(_seedMotifWithoutTrans);
	_seedMotif.append(string(_nbTrans,'@'));
	return 1;
      }else{
	return 0;
      }
    }else{
      _seedMotif.erase (secondAt,1);
      _seedMotif.insert(secondAt-1,1,'@');
      _seedMotif.erase(0,firstNonAt);
      _seedMotif.insert(secondAt-firstNonAt,firstNonAt,'@');
      return 1;
    }//
  }else{
    if (secondAt > 0 ){
      _seedMotif.erase(secondAt   ,1);
      _seedMotif.insert(secondAt-1,1,'@');
      return 1;
    }else{
      if (_nextWithoutTrans()){
	_seedMotif = string(_seedMotifWithoutTrans);
	_seedMotif.append(string(_nbTrans,'@'));
	return 1;
      }else{
	return 0;
      }
    }
  }
}
    
int seed::profile(/* out */int * p_profile_size, /* out */ int ** p_profile) 
{
  
  
  (*p_profile) = new int[_span-1];
  (*p_profile_size) = _span-1 ;
  
  
  for(int i=0 ; i<_span - 1 ; i++){
    (*p_profile)[i] = 0;
    for(int j=0 ; j <_span-i;j++){
      int d = ((int)_seedMotif[j]+(int)_seedMotif[i+j+1]);
      
      if (d == 70)
	(*p_profile)[i] += 1;
      
    }//j
  }//i
  return 0;
}
